<?php
/**
 * IndexerTimestamp
 *
 * PHP version 5
 *
 * @category Class
 * @package  Ensi\CatalogCacheClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * Ensi Catalog Cache
 *
 * Ensi Catalog Cache
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: mail@greensight.ru
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 4.3.1
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace Ensi\CatalogCacheClient\Dto;

use \ArrayAccess;
use \Ensi\CatalogCacheClient\ObjectSerializer;

/**
 * IndexerTimestamp Class Doc Comment
 *
 * @category Class
 * @package  Ensi\CatalogCacheClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */
class IndexerTimestamp implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'IndexerTimestamp';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'id' => 'int',
        'index' => 'string',
        'stage' => 'string',
        'index_hash' => 'string',
        'is_current_index' => 'bool',
        'is_current_stage' => 'bool',
        'is_current' => 'bool',
        'last_schedule' => '\DateTime'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPIFormats = [
        'id' => null,
        'index' => null,
        'stage' => null,
        'index_hash' => null,
        'is_current_index' => null,
        'is_current_stage' => null,
        'is_current' => null,
        'last_schedule' => 'date-time'
    ];

    /**
      * Array of nullable properties. Used for (de)serialization
      *
      * @var boolean[]
      */
    protected static $openAPINullables = [
        'id' => false,
        'index' => false,
        'stage' => false,
        'index_hash' => false,
        'is_current_index' => false,
        'is_current_stage' => false,
        'is_current' => false,
        'last_schedule' => false
    ];

    /**
      * If a nullable field gets set to null, insert it here
      *
      * @var boolean[]
      */
    protected $openAPINullablesSetToNull = [];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

        /**
     * Array of property to nullable mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPINullables()
    {
        return self::$openAPINullables;
    }

    /**
     * Array of nullable field names deliberately set to null
     *
     * @return array
     */
    public function getOpenAPINullablesSetToNull()
    {
        return $this->openAPINullablesSetToNull;
    }

    public function setOpenAPINullablesSetToNull($nullablesSetToNull)
    {
        $this->openAPINullablesSetToNull=$nullablesSetToNull;
        return $this;
    }

    /**
     * Checks if a property is nullable
     *
     * @return bool
     */
    public static function isNullable(string $property): bool
    {
        if (isset(self::openAPINullables()[$property])) {
            return self::openAPINullables()[$property];
        }

        return false;
    }

    /**
     * Checks if a nullable property is set to null.
     *
     * @return bool
     */
    public function isNullableSetToNull(string $property): bool
    {
        if (in_array($property, $this->getOpenAPINullablesSetToNull())) {
            return true;
        }
        return false;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'id' => 'id',
        'index' => 'index',
        'stage' => 'stage',
        'index_hash' => 'index_hash',
        'is_current_index' => 'is_current_index',
        'is_current_stage' => 'is_current_stage',
        'is_current' => 'is_current',
        'last_schedule' => 'last_schedule'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'id' => 'setId',
        'index' => 'setIndex',
        'stage' => 'setStage',
        'index_hash' => 'setIndexHash',
        'is_current_index' => 'setIsCurrentIndex',
        'is_current_stage' => 'setIsCurrentStage',
        'is_current' => 'setIsCurrent',
        'last_schedule' => 'setLastSchedule'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'id' => 'getId',
        'index' => 'getIndex',
        'stage' => 'getStage',
        'index_hash' => 'getIndexHash',
        'is_current_index' => 'getIsCurrentIndex',
        'is_current_stage' => 'getIsCurrentStage',
        'is_current' => 'getIsCurrent',
        'last_schedule' => 'getLastSchedule'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }

    

    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->setIfExists('id', $data, null);
        $this->setIfExists('index', $data, null);
        $this->setIfExists('stage', $data, null);
        $this->setIfExists('index_hash', $data, null);
        $this->setIfExists('is_current_index', $data, null);
        $this->setIfExists('is_current_stage', $data, null);
        $this->setIfExists('is_current', $data, null);
        $this->setIfExists('last_schedule', $data, null);
    }

    public function setIfExists(string $variableName, $fields, $defaultValue)
    {
        if (is_array($fields) && array_key_exists($variableName, $fields) && is_null($fields[$variableName]) && self::isNullable($variableName)) {
            array_push($this->openAPINullablesSetToNull, $variableName);
        }

        $this->container[$variableName] = isset($fields[$variableName]) ? $fields[$variableName] : $defaultValue;

        return $this;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        if ($this->container['id'] === null) {
            $invalidProperties[] = "'id' can't be null";
        }
        if ($this->container['index'] === null) {
            $invalidProperties[] = "'index' can't be null";
        }
        if ($this->container['stage'] === null) {
            $invalidProperties[] = "'stage' can't be null";
        }
        if ($this->container['index_hash'] === null) {
            $invalidProperties[] = "'index_hash' can't be null";
        }
        if ($this->container['is_current_index'] === null) {
            $invalidProperties[] = "'is_current_index' can't be null";
        }
        if ($this->container['is_current_stage'] === null) {
            $invalidProperties[] = "'is_current_stage' can't be null";
        }
        if ($this->container['is_current'] === null) {
            $invalidProperties[] = "'is_current' can't be null";
        }
        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets id
     *
     * @return int
     */
    public function getId()
    {
        return $this->container['id'];
    }

    /**
     * Sets id
     *
     * @param int $id id
     *
     * @return $this
     */
    public function setId($id)
    {


        /*if (is_null($id)) {
            throw new \InvalidArgumentException('non-nullable id cannot be null');
        }*/
        $this->container['id'] = $id;

        return $this;
    }

    /**
     * Gets index
     *
     * @return string
     */
    public function getIndex()
    {
        return $this->container['index'];
    }

    /**
     * Sets index
     *
     * @param string $index The base name of the index (products, categories)
     *
     * @return $this
     */
    public function setIndex($index)
    {


        /*if (is_null($index)) {
            throw new \InvalidArgumentException('non-nullable index cannot be null');
        }*/
        $this->container['index'] = $index;

        return $this;
    }

    /**
     * Gets stage
     *
     * @return string
     */
    public function getStage()
    {
        return $this->container['stage'];
    }

    /**
     * Sets stage
     *
     * @param string $stage The branch where indexing takes place
     *
     * @return $this
     */
    public function setStage($stage)
    {


        /*if (is_null($stage)) {
            throw new \InvalidArgumentException('non-nullable stage cannot be null');
        }*/
        $this->container['stage'] = $stage;

        return $this;
    }

    /**
     * Gets index_hash
     *
     * @return string
     */
    public function getIndexHash()
    {
        return $this->container['index_hash'];
    }

    /**
     * Sets index_hash
     *
     * @param string $index_hash Index hash
     *
     * @return $this
     */
    public function setIndexHash($index_hash)
    {


        /*if (is_null($index_hash)) {
            throw new \InvalidArgumentException('non-nullable index_hash cannot be null');
        }*/
        $this->container['index_hash'] = $index_hash;

        return $this;
    }

    /**
     * Gets is_current_index
     *
     * @return bool
     */
    public function getIsCurrentIndex()
    {
        return $this->container['is_current_index'];
    }

    /**
     * Sets is_current_index
     *
     * @param bool $is_current_index This setting is for the current hash
     *
     * @return $this
     */
    public function setIsCurrentIndex($is_current_index)
    {


        /*if (is_null($is_current_index)) {
            throw new \InvalidArgumentException('non-nullable is_current_index cannot be null');
        }*/
        $this->container['is_current_index'] = $is_current_index;

        return $this;
    }

    /**
     * Gets is_current_stage
     *
     * @return bool
     */
    public function getIsCurrentStage()
    {
        return $this->container['is_current_stage'];
    }

    /**
     * Sets is_current_stage
     *
     * @param bool $is_current_stage This setting is for the current APP_STAGE
     *
     * @return $this
     */
    public function setIsCurrentStage($is_current_stage)
    {


        /*if (is_null($is_current_stage)) {
            throw new \InvalidArgumentException('non-nullable is_current_stage cannot be null');
        }*/
        $this->container['is_current_stage'] = $is_current_stage;

        return $this;
    }

    /**
     * Gets is_current
     *
     * @return bool
     */
    public function getIsCurrent()
    {
        return $this->container['is_current'];
    }

    /**
     * Sets is_current
     *
     * @param bool $is_current This setting is for current settings
     *
     * @return $this
     */
    public function setIsCurrent($is_current)
    {


        /*if (is_null($is_current)) {
            throw new \InvalidArgumentException('non-nullable is_current cannot be null');
        }*/
        $this->container['is_current'] = $is_current;

        return $this;
    }

    /**
     * Gets last_schedule
     *
     * @return \DateTime|null
     */
    public function getLastSchedule()
    {
        return $this->container['last_schedule'];
    }

    /**
     * Sets last_schedule
     *
     * @param \DateTime|null $last_schedule Last schedule time
     *
     * @return $this
     */
    public function setLastSchedule($last_schedule)
    {


        /*if (is_null($last_schedule)) {
            throw new \InvalidArgumentException('non-nullable last_schedule cannot be null');
        }*/
        $this->container['last_schedule'] = $last_schedule;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset): bool
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset): mixed
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value): void
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset): void
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }

    /**
    * Convert object to array
    *
    * @return array
    */
    public function toArray()
    {
        return json_decode(json_encode(ObjectSerializer::sanitizeForSerialization($this)), true);
    }
}


